"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseController = exports.Response = void 0;
var errors_1 = require("../errors");
;
var Response = /** @class */ (function () {
    function Response() {
    }
    return Response;
}());
exports.Response = Response;
;
var BaseController = /** @class */ (function () {
    function BaseController() {
    }
    ;
    BaseController.prototype.ok = function (response, data) {
        if (!data)
            return response.sendStatus(200);
        response.type('application/json');
        return response.status(200).send({ data: data });
    };
    ;
    BaseController.prototype.created = function (response) {
        return response.sendStatus(201);
    };
    ;
    BaseController.prototype.clientError = function (next, message) {
        if (message === void 0) { message = "Bad Request"; }
        return next(new errors_1.GenericValidationError({ error: new Error(message), errorCode: 400 }));
    };
    ;
    BaseController.prototype.unauthorized = function (next, message) {
        if (message === void 0) { message = "Unauthorized"; }
        return next(new errors_1.GenericValidationError({ error: new Error(message), errorCode: 401 }));
    };
    ;
    BaseController.prototype.paymentRequired = function (next, message) {
        if (message === void 0) { message = "Payment required"; }
        return next(new errors_1.GenericValidationError({ error: new Error(message), errorCode: 402 }));
    };
    ;
    BaseController.prototype.forbidden = function (next, message) {
        if (message === void 0) { message = "Forbidden"; }
        return next(new errors_1.GenericValidationError({ error: new Error(message), errorCode: 403 }));
    };
    ;
    BaseController.prototype.notFound = function (next, message) {
        if (message === void 0) { message = "Not found"; }
        return next(new errors_1.GenericValidationError({ error: new Error(message), errorCode: 404 }));
    };
    ;
    BaseController.prototype.conflict = function (next, message) {
        if (message === void 0) { message = "Conflict"; }
        return next(new errors_1.GenericValidationError({ error: new Error(message), errorCode: 409 }));
    };
    ;
    BaseController.prototype.tooMany = function (next, message) {
        if (message === void 0) { message = "Too many requests"; }
        return next(new errors_1.GenericValidationError({ error: new Error(message), errorCode: 429 }));
    };
    ;
    return BaseController;
}());
exports.BaseController = BaseController;
;
